
;**************************************************
;* Lionel d'Hauenens -= Association L.A.B.O. =- *
;* http://www.labo-asso.com/                      *
;**************************************************

.686P
.MODEL FLAT, STDCALL

   OPTION      CASEMAP:NONE
   UNICODE     = 1
   ARGUMENTS   = 0

   ASSUME fs:nothing

   includelib ntoskrnl.lib
   include ntoskrnl.inc
   
   includelib hal.lib
   include hal.inc

   include \masm32\include\windows.inc
   include macro.asm  
   include data.asm

; ##########################################
; #              CONSTANTE                 #
; ##########################################

    _pushad                   equ 020h
    _eax                      equ 01Ch

    STATUS_CANCELLED          equ 0C0000120h
    STATUS_SUCCESS            equ 0   

; ##########################################
; #                  CODE                  #
; ##########################################


.CODE  INIT    ; (pageable)

include hex2ascii.asm
include virtual_physical_mem.asm
include gdt_idt.asm

start:
;int 3
    pushad    

    dbg_println "############################"
    dbg_println "#     get_all_pcr.sys      #"
    dbg_println "############################"
    dbg_println " "
    dbg_println "get_all_pcr : DriverEntry"      
    
    mov eax, cr4
    test eax, cr4_flag_PAE
    je @F
        dbg_println "get_all_pcr : MODE PAE activ."    
@@ :     
    dbg_println "get_all_pcr : Scan memory..."    
    
    ; dsactive les interruptions et passe  l'IRQL max 
    ; **************************************************
    mov ecx, 01Fh
    cli 
    call KfRaiseIrql
    movzx eax,al
    mov dword ptr [current_IRQL], eax

    ; ****************************************** 
    ; Recherche les diffrents offsets utiles
    ; dans la structure KPCR 
    ; ****************************************** 
        xor eax,eax
        mov al, 30h
        push eax
        call get_gdt_directory_base_by_selector    
        or eax,eax
        je debugprint_failed_and_exit    
        mov dword ptr [current_pcr], eax                   
    
    ; Recherche l'offset du champ SelfPcr
    ; ************************************  
        mov edi,eax
        mov ecx, (1000h/4) 
        cld 
        repne scasd
        jnz debugprint_failed_and_exit   
    
        sub edi,4
        sub edi, dword ptr [current_pcr]
        mov dword ptr [KPCR_offset_SelfPcr], edi
                
    ; Recherche l'offset du champ GDT 
    ; ********************************  
        GetGdtbase eax  
        
        mov edi, dword ptr [current_pcr]
        mov ecx, (1000h/4) 
        cld 
        repne scasd
        jnz debugprint_failed_and_exit   
    
        sub edi,4
        sub edi, dword ptr [current_pcr]
        mov dword ptr [KPCR_offset_GDT], edi         
    
    ; Recherche l'offset du champ IDT
    ; ********************************      
        GetIdtbase eax  
        
        mov edi, dword ptr [current_pcr]
        mov ecx, (1000h/4) 
        cld 
        repne scasd
        jnz debugprint_failed_and_exit   
    
        sub edi,4
        sub edi, dword ptr [current_pcr]
        mov dword ptr [KPCR_offset_IDT], edi 

    ; Scanne la mmoire kernel (de 0xFFFFF000  0x80000000)
    ;  la recherche des pcr de chaque processeur actif.
    ; *****************************************************   
    xor eax,eax
    mov dword ptr [index_table], eax
    mov esi, 0FFFFF000h    
                               
boucle_scan :
    test esi, 080000000h
    je fin_scan
        push esi
        call is_virtual_address_valid_and_cache   ; ignore les pages non mises en cache 
        or eax,eax
        je continue_scan
        
        mov eax, dword ptr [KPCR_offset_SelfPcr]
        cmp esi, dword ptr [esi+eax]
        jne continue_scan
        
        mov eax, dword ptr [KPCR_offset_GDT]        
        push dword ptr [esi+eax]
        push  30h
        call get_gdt_directory_base        
        
        cmp eax, esi
        jne continue_scan
        
        ; Find KPCR
        ; **********
            mov eax, dword ptr [index_table]
            cmp eax, 020h
            jae debugprint_failed_and_exit   ; Erreur ! plus de 32 KPCR de trouvs.        
            shl eax, 2
            mov dword ptr [Table_KPCR+eax], esi
            inc dword ptr [index_table]             
continue_scan :
    sub esi, 01000h
    jmp boucle_scan

fin_scan :
    ; restaure l'IRQL et ractive les interruptions
    ; *********************************************
    mov ecx, dword ptr [current_IRQL]
    cmp ecx, 0FFFFFFFFh
    je @F
      call KfLowerIrql     
@@ :    
    sti
   
    ; -------------------------------------------------------------------------
    ; - Affiche les informations sur les PCR de tous les processeurs prsents -
    ; -------------------------------------------------------------------------

    dbg_println "get_all_pcr : *************************************************"

    push offset address_num_proc     ;pointeur du buffer caract.             
    push dword ptr [index_table]                  
    call hex2ascii  
    
    dbg_print_reg_mem   offset message_num_proc 
    dbg_println " "
      
    xor ecx,ecx
    mov cl, 20h
    mov esi,offset Table_KPCR
    
boucle_kpcr :    
    lodsd 
    or eax,eax
    je no_pcr        
        push eax
        call Affiche_info_kpcr
no_pcr :
    loop boucle_kpcr 
    
    dbg_println "get_all_pcr : *************************************************"
sortie :
    dbg_println "get_all_pcr : Sortie..."
    dbg_println " "
    popad
    mov eax, STATUS_CANCELLED
    ret 2*4
    
; #######################################################################################       
; #######################################################################################

debugprint_failed_and_exit :

    ; restaure l'IRQL et ractive les interruptions
    ; *********************************************    
    mov ecx, dword ptr [current_IRQL]
    cmp ecx, 0FFFFFFFFh
    je @F
      call KfLowerIrql      
@@ :    
    sti

    dbg_print_reg_mem   offset string_failed
    jmp sortie

; ###############################################################
; ###############################################################

Affiche_info_kpcr :
    pushad
    mov edi, dword ptr [esp+_pushad+4+(0*4)]  
    
    push offset address_kpcr    ;pointeur du buffer caract.             
    push edi                   
    call hex2ascii    
    
    mov eax, dword ptr [KPCR_offset_IDT]
    push offset address_idt     ;pointeur du buffer caract.             
    push dword ptr[edi+eax]                  
    call hex2ascii   
    
    mov eax, dword ptr [KPCR_offset_GDT]
    push offset address_gdt     ;pointeur du buffer caract.             
    push dword ptr[edi+eax]                  
    call hex2ascii  
    
    dbg_print_reg_mem   offset message_kpcr   
    dbg_print_reg_mem   offset message_idt
    dbg_print_reg_mem   offset message_gdt 
    dbg_println " "
    
    popad
    ret 4
    
; #######################################################################################

end start





















